/**
 * @(#)DocObj.java  12/12/99
 * @author Peter Au
 * All rights reserved.
 * Adapted to use sparce matrix Matthew Carey 7/7/2000
 */

package vishnu.testvis.object;
import vishnu.datablock.*;
import java.util.*;
public class DocObj
{
    private int _number;
    private int _mgNumber;
    private String _description;
//--!!! we don't need to store the whole number, as the actual value is not very important
//--!!! but we need to keep track the doc contains particular related words or not
//--!!! therefore, one bit will do
    private SparseNode _weights, _sparceNode;


    public DocObj(int num, String s,SparseNode w, int mgn)
    {
        _number = num;
        _description=s;
        //_fields=f;
        _weights=w;
        _mgNumber = mgn;
    }

  //public void setWeights(int[] w){_weights=w;}
    public int getNumber()
    {
        return _number;
    }
    public String getDescription()
    {
        return _description;
    }

    public SparseNode getWeights()
    {
        return _weights;
    }
    public float getWeights(int i)
    {
        SparseNode test = _weights;
        while(test != null)
        {
            if(test.getColumn() == i) return test.getValue();
            test = test.getNext();
        }
        return 0;
    }
    static public String getANumberOfWords(String in, int num)
    {
        StringTokenizer st = new StringTokenizer(in);
        StringBuffer buff = new StringBuffer();
        for(int c=0;c<num && st.hasMoreTokens() ;c++)
        {
            if (c>0) buff.append(" ");
            buff.append(st.nextToken());
        }
        String retString = new String(buff);
        return retString;
    }
    
    public String getTrecID()
    {
        StringTokenizer st = new StringTokenizer(_description);
        return st.nextToken();             
    }

    public String format4Fields()
    {
        String s = "";
        s += "<dl>\n";
        s += "  <dt> <a HREF=\"" + _mgNumber +"\">"+ "Document: " + _mgNumber + "</a>\n";
        //s += "  <dd> <b>"+ getANumberOfWords(_description,5) +"</b><br> \n";
	String modDesc = _description.replaceAll("<"," ");
	modDesc = modDesc.replaceAll(">"," ");
        s += "    <dd> <font color=gray> " + modDesc + " </font>\n";
        s += "</dl>\n";
	System.out.println(s);
        return s;
  }


}
