package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.PrintWriter;

import org.greenstone.gsdl3.gs3build.util.XMLTools;

public class DocumentWriter
{
  public DocumentWriter()
  {
  }

  public boolean writeDocument(DocumentInterface document, PrintWriter output)
  {		
    // TODO: output document in METS format, with Greenstone-specific metadata
    // placed in a wrapper inside the descriptive metadata block
    String tag = XMLTools.getOpenTag("mets", "mets");
    if (document.getID() != null)
    { tag = XMLTools.addAttribute(tag, "OBJID", document.getID().toString());
    }
    output.println(tag);
    
    // Writing the structural metadata:
    //   if in "Create METS" mode:
    //     take all the documents as being in the one group, of the "physical"
    //     document; particular document plugins may extend this behaviour,
    //     which would suggest placing it in the AbstractDocument or similar
    //     class?!
    document.getDocumentMetadata().write(output);

    // TODO: only output the document if there is some
    // content/formatting change between the original and
    // what greenstone actually does; if the original is
    // good, then place a marker saying "get the document
    // "from the original file"
    if  (document.isMETSCompatible())
    {
      document.getDocumentFiles().write(output);
      document.getDocumentStructure().write(output);
    }
    else
    { DocumentWriter writer = document.getMETSWriter();
    
      // ensure that this call isn't recursive - 
      // TODO: This is a rather naive check and needs improving
      if (writer != this) {
	writer.writeDocument(document, output);
      }
    }
    output.write("</mets:mets>\n");
    return true;
  }
}
